/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#ifndef APPUTIL_H
#define APPUTIL_H
#include "libraries/fstUtils.h"
#include <algorithm>
using namespace fst;
using namespace std;

void fixMinMaxSkel(blockskel *thisskel, map <int, set<int> > *adjlist, int* nodedismin, int numnodes, int minmax);
void fixMidlSkel(blockskel *thisskel, map <int, set <int> > *adjlist, map <int, set <int> > *adjlistrev);
blockskel findMinSfa(map <int, set <int> > *adjlist, map <int, set <int> > *adjlistrev, int* nodedismin, int numnodes, pair<Edge, Edge> thepair);
bool pathwtcomp (pair<string,double> fir, pair<string,double> sec);
double probDynMult(map <int, set <int> > *adjlist, map < Edge, block> *blockdata, int startnode, map <int, double> *memo);
block getBlockData(blockskel thisskel, map <Edge, block> *blockdata, int K, int storepaths, int* scratch);
void updateStructures(blockskel thisskel, block *thisblk, map <int, set<int> > *tmpadjlist, map <int, set<int> > *tmpadjlistrev, map <Edge, block> *tmpblockdata);
set < Edge > getEdgeSet(map <int, set <int> > sfa);
set < Edge > intersectEdgeSets(set < Edge > s1, set < Edge > s2);
#endif
